// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_ACURA_MOM_BACKEND/grmi"
	meta "LAPP_ACURA_MOM_BACKEND/meta/base"
	model "LAPP_ACURA_MOM_BACKEND/models/base"
	"fmt"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : ArtQtyAllocateDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : ArtQtyAllocate的数据访问对象实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-11-24 14:18:42
 *
 ******************************************************************************/
type ArtQtyAllocateDAOImplement struct {
	session *xorm.Session
	meta    *grmi.Entity
	plantNr int
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewArtQtyAllocateDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个ArtQtyAllocateDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *
 * @Function Parameters      : 基本主键
 *
 * @Return Value             : ArtQtyAllocateDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-11-24 14:18:42
 *
 ******************************************************************************/
func NewArtQtyAllocateDAOImplement(session *xorm.Session, plantNr int, userid string) *ArtQtyAllocateDAOImplement {
	return &ArtQtyAllocateDAOImplement{session, &meta.ArtQtyAllocate, plantNr, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtQtyAllocateDAO.InsertOne
 *
 ******************************************************************************/
func (impl *ArtQtyAllocateDAOImplement) InsertOne(entity *model.ArtQtyAllocate) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtQtyAllocateDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *ArtQtyAllocateDAOImplement) DeleteOne(attriCode int, workLineId string, subObject string, projectId string, totalPlanty int, pO string, assignPlanty int) error {
	_, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, attriCode, workLineId, subObject, projectId, totalPlanty, pO, assignPlanty}).Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtQtyAllocateDAO.SelectOne
 *
 ******************************************************************************/
func (impl *ArtQtyAllocateDAOImplement) SelectOne(attriCode int, workLineId string, subObject string, projectId string, totalPlanty int, pO string, assignPlanty int) (*model.ArtQtyAllocate, error) {
	var data model.ArtQtyAllocate
	ok, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, attriCode, workLineId, subObject, projectId, totalPlanty, pO, assignPlanty}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtQtyAllocateDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *ArtQtyAllocateDAOImplement) UpdateOne(entity *model.ArtQtyAllocate) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtQtyAllocateDAO.Insert
 *
 ******************************************************************************/
func (impl *ArtQtyAllocateDAOImplement) Insert(entities *[]model.ArtQtyAllocate) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
	}
	_, err := impl.session.Table(impl.meta.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtQtyAllocateDAO.Delete
 *
 ******************************************************************************/
func (impl *ArtQtyAllocateDAOImplement) Delete(entities *[]model.ArtQtyAllocate) error {
	for _, entity := range *entities {
		entity.PlantNr = impl.plantNr
		_, err := impl.session.Table(impl.meta.TableName).ID(entity.GetKey()).Delete(impl.meta.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtQtyAllocateDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *ArtQtyAllocateDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ArtQtyAllocate_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtQtyAllocateDAO.Select
 *
 ******************************************************************************/
func (impl *ArtQtyAllocateDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.ArtQtyAllocate, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ArtQtyAllocate_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy(meta.ArtQtyAllocate_PlantNr.ColumnName)
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.ArtQtyAllocate, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtQtyAllocateDAO.SelectCols
 *
 ******************************************************************************/
func (impl *ArtQtyAllocateDAOImplement) SelectCols(predicates []grmi.Predicate, orderByFields []grmi.Field, cloumns []string) ([]model.ArtQtyAllocate, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ArtQtyAllocate_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy(meta.ArtQtyAllocate_PlantNr.ColumnName)
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.ArtQtyAllocate, 0, 10)
	err := session.Cols(cloumns...).Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtQtyAllocateDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *ArtQtyAllocateDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ArtQtyAllocate_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(impl.meta.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by " + meta.ArtQtyAllocate_PlantNr.ColumnName
	if orderByFields != nil {
		for _, field := range orderByFields {
			if orderBy == " order by " {
				orderBy += field.ColumnName
			} else {
				orderBy += ", " + field.ColumnName
			}
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.ArtQtyAllocate, 0, 10)
	where = " where " + where
	err = impl.session.Table(impl.meta.TableName).SQL("select * from ["+impl.meta.TableName+"]"+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtQtyAllocateDAO.Update
 *
 ******************************************************************************/
func (impl *ArtQtyAllocateDAOImplement) Update(entities *[]model.ArtQtyAllocate) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
		_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtQtyAllocateDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *ArtQtyAllocateDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.ArtQtyAllocate, columns ...string) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ArtQtyAllocate_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	columns = append(columns, meta.ArtQtyAllocate_LastUser.Name)
	entity.LastUser = impl.userid
	_, err := session.Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/ArtQtyAllocateDAO.SelectByArtId
 *
 ******************************************************************************/
func (impl *ArtQtyAllocateDAOImplement) SelectByArtId(artId string, projectId string, attrCodeLi []int) ([]model.ArtQtyAllocate, error) {
	result := make([]model.ArtQtyAllocate, 0)
	parameters := []interface{}{impl.plantNr, projectId, model.MES_MATCH_ALL, artId}
	where := fmt.Sprintf("%s = ? and %s = ? and ( %s = ? or %s = ? )",
		meta.ArtQtyAllocate_PlantNr.ColumnName,
		meta.ArtQtyAllocate_ProjectId.ColumnName,
		meta.ArtQtyAllocate_SubObject.ColumnName,
		meta.ArtQtyAllocate_SubObject.ColumnName)

	err := impl.session.Table(impl.meta.TableName).Where(where, parameters...).In(meta.ArtQtyAllocate_AttriCode.SortColumnName, attrCodeLi).OrderBy(meta.ArtQtyAllocate_AttriCode.SortColumnName).Find(&result)
	return result, err
}
